; ****************************************************************************
;       TITLE: HELP2.sc 
;     SESSION: PAOLINI - Providing Custom Help in Paradox 4 Apps
;   COPYRIGHT: (c) 1993 - Dan Paolini - DataStar International
; DESCRIPTION: Example of MENU-BASED Help
; ****************************************************************************

PROC Help!MainMenu.u()
Private  h2, y2
   DynArray y2[]
      y2["Title"] = "This is the Title of Help Screen 2"
      y2["HasFrame"] = False
      y2["CanMove"] = False
      y2["Style"] = 63

   Window Create Floating @ 2,3 Height 20 Width 74 Attributes y2 To h2
   Window Select h2
   SetCanvas h2
   Canvas OFF
   @ 1,1
   Style Attribute 63
   Frame Single From 0,0 To 19,73
   SetMargin 1
TEXT

   BEEPĿ
           1 Beep        Play One Beep and return to Menu
           2 Beeps       Play Two Beeps and return to Menu
           3 Beeps       Play Three Beeps and return to Menu

   SOUNDSĿ
           Siren         Play an alert Siren and wait for an Event
           Scale Up      Play three octave chromatic Scale up
           Scale Down    Play three octave chromatic Scale down

   QUIT              Quit this Help Demonstration
           Ŀ
            Drawbacks:    Only available while at a Menu   
            Benefits:     Each menu can have its own Help  
                          Grow into Context Help System    
           

ENDTEXT

   PaintCanvas Attribute 48 3,27,12,72
   PaintCanvas Attribute 62 3,14,10,25
   PaintCanvas Border
               Attribute 59 0,0,19,73
   PaintCanvas Attribute 48 0,0,0,72
   PaintCanvas Attribute 48 0,0,19,0
   PaintCanvas Attribute  8 14,14,18,63
   PaintCanvas Attribute 31 13,12,17,61
   PaintCanvas Border
               Attribute 25 13,12,17,61
   PaintCanvas Attribute 16 13,61,17,61
   PaintCanvas Attribute 16 17,13,17,61
   Canvas ON
   Message "Press any key to continue..."
   retval = GetChar()
   WinClose
   SetCanvas Default
   Return
ENDPROC

PROC Help!Beep.u()
Private  h2, y2
   DynArray y2[]
      y2["Title"] = "Help for Beep"
      y2["HasFrame"] = False
      y2["CanMove"] = False
      y2["Style"] = 63

   Window Create Floating @ 2,3 Height 20 Width 74 Attributes y2 To h2
   Window Select h2
   SetCanvas h2
   Canvas OFF
   @ 1,1
   Style Attribute 63
   Frame Single From 0,0 To 19,73
   SetMargin 1
TEXT

                 
                 
                                     
                                     
                   
                   
                                  
                                  
                 
                 

           Ŀ
                                                           
                You need help for Beep!?!?!  Get Real!     
                                                           
           

ENDTEXT

   PaintCanvas Border
               Attribute 59 0,0,19,73
   PaintCanvas Attribute 48 0,0,0,72
   PaintCanvas Attribute 48 0,0,19,0
   PaintCanvas Attribute  8 14,14,18,63
   PaintCanvas Attribute 31 13,12,17,61
   PaintCanvas Border
               Attribute 25 13,12,17,61
   PaintCanvas Attribute 16 13,61,17,61
   PaintCanvas Attribute 16 17,13,17,61
   Canvas ON
   Message "Press any key to continue..."
   retval = GetChar()
   WinClose
   SetCanvas Default
   Return
ENDPROC


   SHOWPULLDOWN
      "Beep"               : "Play some Beeps"        : "BEEP.NODE"
      SUBMENU
         "1 Beep"          : "Play One Beep"          : "BEEP.ONE",
         "2 Beeps"         : "Play Two Beeps"         : "BEEP.TWO",
         "3 Beep"          : "Play Three Beeps"       : "BEEP.THREE",
         "Help"            : "Help for Beeps"         : "HELP!BEEP"
      ENDSUBMENU,
      "Sound"              : "Play some Sounds"       : "SOUND.NODE"
      SUBMENU
         "Siren"           : "Play a High/Low Siren"  : "SOUND.SIREN",
         "Sound ~U~p"      : "Play a Scale Up"        : "SCALE.UP",
         "Sound ~D~own"    : "Play a Scale Down"      : "SCALE.DOWN"
      ENDSUBMENU,
      "Help"               : "Help on our Application": "HELP!MAINMENU",
      "Quit"               : "Quit this Demonstration": "QUIT.NODE"
      SUBMENU
         "Yes"             : "Hasta la vista, Baby"   : "QUIT.YES",
         "No"              : "I'll be back"           : "QUIT.NO"
      ENDSUBMENU
   ENDMENU

WHILE true
   GetMenuSelection to a2
   SWITCH
      CASE a2 = "QUIT.YES"          : QUITLOOP
      CASE Search("HELP!",a2) = 1   : ExecProc a2 + ".U"
   ENDSWITCH
ENDWHILE



