; ****************************************************************************
;       TITLE: HELP6.sc 
;     SESSION: PAOLINI - Providing Custom Help in Paradox 4 Apps
;   COPYRIGHT: (c) 1993 - Dan Paolini - DataStar International
; DESCRIPTION: Example of TABLE-BASED Context-Sensitive Help
; ****************************************************************************

PROC hsEngineTable.u(context.a)
Private  old.h,
         formview.l,
         table.a,
         field.a
   table.a = Upper(Table())
   field.a = Upper(Field())
   Window Handle Image ImageNo() To old.h
   formview.l = IsFormView()
   Window Select help.db.h
   MoveTo [Context]
   context.l = true
   IF NImages() > 0 THEN
      Locate "!IMAGE", table.a, field.a
      IF NOT retval THEN
         Locate "!IMAGE", table.a
         context.l = NOT retval
      ELSE
         context.l = false
      ENDIF
   ENDIF
   IF context.l THEN
      Locate context.a
      IF NOT retval THEN
         Locate "HELP"
      ENDIF
   ENDIF

   Window Select help.mb.h
   Window Move help.mb.h To 1,0
   Message "Press <F2> when Finished..."
   Wait Field
   Until "F2"
   Window Move help.mb.h To -200,-200

   Window Select old.h
   IF formview.l THEN
      FormKey
   ENDIF
   Return
ENDPROC

PROC myWaitHandler.n(x,y,z)
   SWITCH
      CASE y["KeyCode"] = -84 :
         IF NOT IsBlank(fieldmsg.y[Table()+"_"+Field()]) THEN
            msContinue!.u("Help for the [" + Field() + "] Field",
                           fieldmsg.y[Table()+"_"+Field()],116,"GRAY",0)
         ELSE
            hsEngineTable.u(context.a)
         ENDIF
         Return 1
      CASE y["KeyCode"] = -35 :
         hsEngineTable.u(context.a)
         Return 1
      OTHERWISE :
         Return 2
   ENDSWITCH
ENDPROC

   Play "DS4_UTIL"
   context.a = "REP"
   DynArray fieldmsg.y[]
      fieldmsg.y["D\\Super_SuperId"]      = "What the heck is a Supervisor Group ID?  Well, here, we could say."
      fieldmsg.y["D\\Super_SLastName"]    = ""
      fieldmsg.y["D\\Super_SFirstName"]   = ""
      fieldmsg.y["D\\Super_DeptCode"]     = "Press <F1> for Table Lookup"
      fieldmsg.y["D\\Super_MgrId"]        = "Press <F1> for Table Lookup"
      fieldmsg.y["D\\Super_UnitId"]       = "" ;Press <F1> for Table Lookup"
      fieldmsg.y["D\\Super_SuperCode"]    = ""
      fieldmsg.y["D\\Super_Shift"]        = "Enter 1, 2, or 3"
      fieldmsg.y["D\\Super_SEmplId"]      = ""
      fieldmsg.y["D\\Super_DAEmplid"]     = "Press <F1> for Table Lookup"

   View "Sys\\AppHelp"
   Window Handle Current To help.db.h
   Window Move help.db.h To -200,-200
   MoveTo [Help]
   FieldView
   Window Handle Current To help.mb.h
   Window Move help.mb.h To -200,-200
   DynArray w.y[]
      w.y["CanClose"] = False
   Window SetAttributes help.mb.h From w.y
   Window Select help.db.h
   View "D\\Super"
   Window Move GetWindow() To -200,-200
   PickForm "2"
   Window Handle Form To h4
   DynArray y4[]
      y4["Maximized"] = True
      y4["HasFrame"] = False
   Window SetAttributes h4 From y4

   Message ""
   WAIT Table
      Proc "myWaitHandler.n"
         Key "F2", -84, -35
   ENDWAIT


