; ****************************************************************************
;       TITLE: HELP7.sc 
;     SESSION: PAOLINI - Providing Custom Help in Paradox 4 Apps
;   COPYRIGHT: (c) 1993 - Dan Paolini - DataStar International
; DESCRIPTION: Example of DIALOG BOX-BASED Context-Sensitive Help
; ****************************************************************************

PROC myWaitHandler.n(x,y,z)
   SWITCH
      CASE y["KeyCode"] = -84 :
         IF NOT IsBlank(fieldmsg.y[Table()+"_"+Field()]) THEN
            msContinue!.u("Help for the [" + Field() + "] Field",
                           fieldmsg.y[Table()+"_"+Field()],116,"GRAY",0)
         ELSE
            hsEngine.u(context.a,g.help.y)
         ENDIF
         Return 1
      CASE y["KeyCode"] = -35 :
         hsEngine.u(context.a,g.help.y)
         Return 1
      OTHERWISE :
         Return 2
   ENDSWITCH
ENDPROC

   GetColors To g.appcolors.y
   Play "DS4_HELP"
   Play "DS4_UTIL"
   DynArray fieldmsg.y[]
      fieldmsg.y["D\\Super_SuperId"]      = "What the heck is a Supervisor Group ID?  Well, here, we could say."
      fieldmsg.y["D\\Super_SLastName"]    = ""
      fieldmsg.y["D\\Super_SFirstName"]   = ""
      fieldmsg.y["D\\Super_DeptCode"]     = "Press <F1> for Table Lookup"
      fieldmsg.y["D\\Super_MgrId"]        = "Press <F1> for Table Lookup"
      fieldmsg.y["D\\Super_UnitId"]       = "" ;Press <F1> for Table Lookup"
      fieldmsg.y["D\\Super_SuperCode"]    = ""
      fieldmsg.y["D\\Super_Shift"]        = "Enter 1, 2, or 3"
      fieldmsg.y["D\\Super_SEmplId"]      = ""
      fieldmsg.y["D\\Super_DAEmplid"]     = "Press <F1> for Table Lookup"

   DynArray g.help.y[]
      g.help.y["MOUSE"] = "ds4HelpMOUSE.u"
      g.help.y["MENUS"] = "ds4HelpMENUS.u"
      g.help.y["KEYS"] = "ds4HelpKEYS.u"
      g.help.y["HELP"] = "ds4HelpHELP.u"
      g.help.y["FIND"] = "ds4HelpFIND.u"
   DynArray g.helpindex.y[]
      g.helpindex.y["MOUSE"] = "Help for Using Your Mouse"
      g.helpindex.y["MENUS"] = "Help Using Application Menus"
      g.helpindex.y["KEYS"] = "Help Using The Keyboard"
      g.helpindex.y["HELP"] = "Help on Using Help"
      g.helpindex.y["FIND"] = "Help on Finding or Locating Data"

   context.a = "REP"

   View "D\\Super"
   PickForm "2"
   Window Handle Form To h4
   DynArray y4[]
      y4["Maximized"] = True
      y4["HasFrame"] = False
   Window SetAttributes h4 From y4

   Message ""
   WAIT Table
      Proc "myWaitHandler.n"
         Key "F2", -84, -35
   ENDWAIT

